import java.awt.*;
import java.awt.event.*;

import javax.swing.*;
import javax.swing.border.*;

public class OptionsDialog extends JDialog{
	
	final JFrame _frame = new JFrame();
	
// node's components
	private JLabel _nodeFillLabelText;
	private JPanel _nodeColorView;
	private Color _nodeColor;
	
// Connector's components
	private JLabel _conFillLabelText;
	private JPanel _connColorView;
	private Color _connectorColor;
	
// Anchor's components
	private JCheckBox _showAnchorsBox;
	
	private JLabel _anchorColorLabel;
	private JLabel _anchorStyleLabel;
	private JPanel _anchorColorView;
	
	private boolean _showAnchors;
	private Color _anchorColor;
	
	private int _anchorStyleProp;
	private int anchorStyle = 0;
		
	private JToolBar _anchorStyle;
	private JButton _circleBtn;
	private JButton _rectBtn;
	private JButton _xBtn;
	
	
//Grid's components	
	private boolean _showGrid;
	private Color _backColor;
	
	
	private JCheckBox _showGridBox;
	private JLayeredPane _anchorsLayered;
	private JColorChooser _colorDialog;
	private JButton _okBut;
	private JButton _cancelBut;
	
	private boolean _accepted;
	
	private JLabel _backLabelText;
	private JPanel _bgColorView;
	
	OptionsDialog(JFrame parent){
		
		super(parent, true);
		_colorDialog = new JColorChooser();
		
		_showGridBox = new JCheckBox();
		_showGridBox.setName("_showGridBox");
		_showGridBox.setText("Show grid");
		_showGridBox.setBounds(5, 10, 90, 20);
		
		_backLabelText = new JLabel();
		_backLabelText.setName("_backLabelText");
		_backLabelText.setText("Background Color:");
		_backLabelText.setBounds(5, 35, 120, 20);
		
		_nodeFillLabelText = new JLabel();
		_nodeFillLabelText.setName("_nodeFillLabelText");
		_nodeFillLabelText.setText("Node fill color:");
		_nodeFillLabelText.setBounds(5, 60, 120, 20);
		
		
		_conFillLabelText = new JLabel();
		_conFillLabelText.setName("_conFillLabelText");
		_conFillLabelText.setText("Connector fill color:");
		_conFillLabelText.setBounds(5, 85, 120, 20);
		
		
		
		_bgColorView = new JPanel();
		_bgColorView.setName("_bgColorView");
		_bgColorView.setBounds(135, 35, 80, 20);
		_bgColorView.setBorder(new LineBorder(Color.black));
		_bgColorView.addMouseListener(new MouseAdapter(){
			public void	mousePressed(MouseEvent e) {
				ColorChooser _newColor = new ColorChooser(_frame);
				
				_newColor.show(true);
				
				if(_newColor.getAccepted() == true)
					setBackgroundColor(_newColor._colorChooser.getColor());
			}
		});
		
		
		_nodeColorView = new JPanel();
		_nodeColorView.setName("_nodeColorView");
		_nodeColorView.setBounds(135, 60, 80, 20);
		_nodeColorView.setBorder(new LineBorder(Color.black));
		_nodeColorView.addMouseListener(new MouseAdapter(){
			public void	mousePressed(MouseEvent e) {
				ColorChooser _newColor = new ColorChooser(_frame);
				
				_newColor.show(true);
				
				if(_newColor.getAccepted() == true)
					setNodeColor(_newColor._colorChooser.getColor());
			}
		});
		
		
		_connColorView = new JPanel();
		_connColorView.setName("_connColorView");
		_connColorView.setBounds(135, 85, 80, 20);
		_connColorView.setBorder(new LineBorder(Color.black));
		_connColorView.addMouseListener(new MouseAdapter(){
			public void	mousePressed(MouseEvent e) {
				ColorChooser _newColor = new ColorChooser(_frame);
				
				_newColor.show(true);
				
				if(_newColor.getAccepted() == true)
					setConnectorColor(_newColor._colorChooser.getColor());
			}
		});
		
		_anchorsLayered = new JLayeredPane();
		_anchorsLayered.setName("_anchorsLayered");
		_anchorsLayered.setBounds(5, 110, 212, 110);
		_anchorsLayered.setBorder(BorderFactory.createTitledBorder("Anchors"));
		
		_showAnchorsBox = new JCheckBox();
		_showAnchorsBox.setName("_showAnchorsBox");
		_showAnchorsBox.setText("Show anchors");
		_showAnchorsBox.setBounds(15, 130, 130, 20);
		
		_anchorColorLabel = new JLabel();
		_anchorColorLabel.setName("_anchorColorLabel");
		_anchorColorLabel.setText("Anchor color:");
		_anchorColorLabel.setBounds(15, 155, 90, 20);
		
		_anchorStyleLabel = new JLabel();
		_anchorStyleLabel.setName("_anchorColorLabel");
		_anchorStyleLabel.setText("Anchor style:");
		_anchorStyleLabel.setBounds(15, 180, 90, 20);
		
		_anchorColorView = new JPanel();
		_anchorColorView.setName("_anchorColorView");
		_anchorColorView.setBounds(120, 155, 80, 20);
		_anchorColorView.setBorder(new LineBorder(Color.black));
		_anchorColorView.addMouseListener(new MouseAdapter(){
			public void mousePressed(MouseEvent e){
				ColorChooser _newColor = new ColorChooser(_frame);
				
				_newColor.show(true);
				
				if(_newColor.getAccepted() == true)
					setAnchorColor(_newColor._colorChooser.getColor());
			}
		});
		
		_okBut = new JButton();
		_okBut.setName("_okBut");
		_okBut.setText("Ok");
		_okBut.setBounds(8,230,95,30);
		_okBut.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				OnOk();
			}
		});
		
		_cancelBut = new JButton();
		_cancelBut.setName("_cancelBut");
		_cancelBut.setText("Cancel");
		_cancelBut.setBounds( 120, 230, 95, 30);
		_cancelBut.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				OnCancel();
			}
		});
		
		
		
		
		ImageIcon _circleImg = this.createImageIcon("Icons/circle.png");
		ImageIcon _rectImg = this.createImageIcon("Icons/rectangle.png");
		ImageIcon _xImg = this.createImageIcon("Icons/x.png");
		
		_circleBtn = new JButton( _circleImg);
		_circleBtn.setPreferredSize(new Dimension(16,16));
		_circleBtn.setToolTipText("Circle");
		_circleBtn.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				setAnchorStyle(0);
				_circleBtn.setEnabled(false);
				_rectBtn.setEnabled(true);
				_xBtn.setEnabled(true);
			}
		});
		
		_rectBtn = new JButton(_rectImg);
		_rectBtn.setPreferredSize(new Dimension(16,16));
		_rectBtn.setToolTipText("Rectangle");
		_rectBtn.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				setAnchorStyle(1);
				_circleBtn.setEnabled(true);
				_rectBtn.setEnabled(false);
				_xBtn.setEnabled(true);
			}
		});
		
		_xBtn = new JButton(_xImg);
		_xBtn.setPreferredSize(new Dimension(16,16));
		_xBtn.setToolTipText("X");
		_xBtn.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				setAnchorStyle(2);
				_circleBtn.setEnabled(true);
				_rectBtn.setEnabled(true);
				_xBtn.setEnabled(false);
			}
		});
		
		_anchorStyle = new JToolBar();
		_anchorStyle.setName("_anchorStyle");
		_anchorStyle.setBounds(120, 180, 80, 30);
		_anchorStyle.setFloatable(false);
		_anchorStyle.setRollover(true);
		_anchorStyle.add(_circleBtn);
		_anchorStyle.add(_rectBtn);
		_anchorStyle.add(_xBtn);
		
		
		
		
		Container cp = this.getContentPane();
		cp.setLayout(null);
		
		cp.add(_showGridBox);
		cp.add(_backLabelText);
		cp.add(_nodeFillLabelText);
		cp.add(_conFillLabelText);
		cp.add(_bgColorView);
		cp.add(_nodeColorView);
		cp.add(_connColorView);
		cp.add(_anchorsLayered);
		cp.add(_showAnchorsBox);
		cp.add(_anchorColorLabel);
		cp.add(_anchorStyleLabel);
		cp.add(_anchorColorView);
		cp.add(_anchorStyle);
		cp.add(_okBut);
		cp.add(_cancelBut);
		
		setTitle("Options");
		setSize(230, 300);
		setResizable(false);
	}

	protected static ImageIcon createImageIcon(String path) {
	    java.net.URL imgURL = OptionsDialog.class.getResource(path);
	    
		
	    if (imgURL != null) {
	        return new ImageIcon(imgURL);
	    } else {
	        System.err.println("Couldn't find file: " + path);
	        return null;
	    }
	}
	
	
	/**
	 * Handles the OK button click.
	 */
	public void OnOk(){
		_accepted = true;
		
		this.setVisible(false);
	}
	
	/**
	 * Handles the Cancel button click.
	 */
	public void OnCancel(){
		_accepted = false;
		
		this.setVisible(false);
	}
	
	
	
	
	/*
	* set get ShowGrid
	*/
	public void setShowGrid(Boolean _showGridBool){
		
		_showGridBox.setSelected(_showGridBool);
	}
	
	public Boolean getShowGrid(){
		return _showGridBox.isSelected();
	}
	
	
	/*
	 * set get BackgoundColor
	 */
	public void setBackgroundColor(Color _color){
		_bgColorView.setBackground(_color);
		
	}
	
	public Color getBackgroundColor(){
		return _bgColorView.getBackground();
	}
	
	
	/*
	 * set get NodeColor
	 */
	public void setNodeColor(Color _color){
		_nodeColorView.setBackground(_color);
	}
	
	public Color getNodeColor(){
		return _nodeColorView.getBackground();
	}
	
	/*
	 * set get ConnectorColor
	 */
	public void setConnectorColor(Color _color){
		_connColorView.setBackground(_color);
	}
	
	public Color getConnectorColor(){
		return _connColorView.getBackground();
	}
	
	/*
	 * set get ShowAnchor
	 */
	public void setShowAnchor(Boolean _show){
		_showAnchorsBox.setSelected(_show);
		
/*here		switch(anchorStyle){
			case 0: 
				_circleBtn.setEnabled(false);
				_rectBtn.setEnabled(true);
				_xBtn.setEnabled(true);
				break;
			case 1:
				_circleBtn.setEnabled(true);
				_rectBtn.setEnabled(false);
				_xBtn.setEnabled(true);
				break;
			case 2:
				_circleBtn.setEnabled(true);
				_rectBtn.setEnabled(true);
				_xBtn.setEnabled(false);
				break;
		}
*/	}
	
	public boolean getShowAnchor(){
		return _showAnchorsBox.isSelected();
	}
	
	/*
	 * set get AnchorColor
	 */
	public void setAnchorColor(Color _color){
		_anchorColorView.setBackground(_color);
	}
	
	public Color getAnchorColor(){
		return _anchorColorView.getBackground();
	}
	
	/*
	 * set get AnchorStyle
	 */
	public void setAnchorStyle(int _style){
		anchorStyle = _style;
		
		switch(anchorStyle){
			case 0: 
				_circleBtn.setEnabled(false);
				_rectBtn.setEnabled(true);
				_xBtn.setEnabled(true);
				break;
			case 1:
				_circleBtn.setEnabled(true);
				_rectBtn.setEnabled(false);
				_xBtn.setEnabled(true);
				break;
			case 2:
				_circleBtn.setEnabled(true);
				_rectBtn.setEnabled(true);
				_xBtn.setEnabled(false);
				break;
		}
		
	}
	
	public int getAnchorStyle(){
		return anchorStyle;
	}
	
	/*
	 * get Accepted
	 */
	public boolean getAccepted(){
		return _accepted;
	}
	
} 