import java.io.*;

import java.awt.*;
import java.awt.event.*;

import javax.swing.*;
import javax.swing.tree.*;
import javax.swing.event.*;
import javax.swing.border.*;

import com.mindfusion.diagramming.*;
/**
 * Sample application using Frame.
 *
 * @author
 * @version 1.00 06/08/08
 */
public class SWDesignerFrame extends JFrame {


    //main menu//
    private JMenuBar _menuBar;
    private JMenu _menuProject;
	private JMenuItem _menuNew;
	private JMenuItem _menuOpen;
	private JMenuItem _menuSave;
	private JMenuItem _menuClose;
	private JMenuItem _printPreview;
	private JMenuItem _menuExit;
	private JMenu _menuDiagram;
	private JMenuItem _menuDelete;
	private JMenuItem _menuAdd;



	//popup menu//
	private JPopupMenu _popupMenu;
	private JMenuItem _cmenuRename;
	private JMenuItem _cmenuDelete;
	private JMenuItem _cmenuAdd;


    private JPanel _inSplitPanel;
    private JSplitPane _split;

    private JTree _tree;
    DefaultMutableTreeNode _top;

    //Flags
    boolean _onOffSaveClose = false;
    boolean _onOffAddDel = false;

    private JDesktopPane _desktop;
    private JScrollPane _deskScroll;
    Container cp;
    Project _project;
    TreeNode _selectableNode;

    private JFileChooser _fileChooser;
    private File _file;

    private static File _projectDir;

    /**
     * The constructor.
     */
     public SWDesignerFrame() {

        //main menu//
	    _menuBar = new JMenuBar();
    	_menuProject = new JMenu("Project");
		_menuNew = new JMenuItem("New");
		_menuOpen = new JMenuItem("Open");
		_menuSave = new JMenuItem("Save");
		_printPreview = new JMenuItem("Print Preview");
		_menuExit = new JMenuItem("Exit");
		_menuDiagram = new JMenu("Diagram");
		_menuDelete = new JMenuItem("Delete");
		_menuClose = new JMenuItem("Close");

        //popup menu//
        _popupMenu = new JPopupMenu();
		_cmenuRename = new JMenuItem();
		_cmenuDelete = new JMenuItem();
		_menuAdd = new JMenuItem("Add");

		_inSplitPanel = new JPanel();
        _split = new JSplitPane();

     	_top = new DefaultMutableTreeNode("Project", true);
  		_tree = new JTree(_top);

    	_desktop = new JDesktopPane();
    	_deskScroll = new JScrollPane(_desktop);
    	_deskScroll.setAutoscrolls(true);

    	_fileChooser = new JFileChooser ();

    	_projectDir = new File("Projects");


    	//
		//_menuProject
		//
		_menuProject.addMouseListener(new MouseAdapter(){
			public void mouseEntered(MouseEvent e){
				onMenuEntered();
			}
		});
		_menuProject.add(_menuNew);
		_menuProject.add(_menuOpen);
		_menuProject.add(_menuSave);
		_menuProject.add(_menuClose);
		_menuProject.add(_printPreview);
		_menuProject.addSeparator();
		_menuProject.add(_menuExit);



    	//
		//_menuNew
		//
		_menuNew.setName("&New...");
		_menuNew.setMnemonic(KeyEvent.VK_N);
		_menuNew.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_N, ActionEvent.CTRL_MASK));
		_menuNew.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				onFileNew();
			}
		});

        //
		//_menuOpen
		//
		_menuOpen.setName("&Open...");
		_menuOpen.setMnemonic(KeyEvent.VK_O);
		_menuOpen.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_0, ActionEvent.CTRL_MASK));
		_menuOpen.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				onFileOpen();
			}
		});

		//
		//_menuSave
		//
		_menuSave.setName("&Save");
		_menuSave.setMnemonic(KeyEvent.VK_S);
		_menuSave.setEnabled(_onOffSaveClose);
		_menuSave.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_S, ActionEvent.CTRL_MASK));
		_menuSave.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				onFileSave();
			}
		});

		//
		//_printPreview
		//
		_printPreview.setName("_printPreview");
		_printPreview.setText("Print Preview");
		_printPreview.setMnemonic(KeyEvent.VK_T);
		_printPreview.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_T, ActionEvent.CTRL_MASK));
		_printPreview.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				onFilePrintPreview();
			}
		});

		//
		//_menuClose
		//
		_menuClose.setName("&Close");
		_menuClose.setMnemonic(KeyEvent.VK_E);
		_menuClose.setEnabled(_onOffSaveClose);
		_menuClose.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_E, ActionEvent.CTRL_MASK));
		_menuClose.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e)
			{
				try
				{
					onFileClose();
				} catch (XmlException e1)
				{
					// TODO Auto-generated catch block
					e1.printStackTrace();
				}
			}
		});

		//
		//_menuExit
		//
		_menuExit.setName("&Exit");
		_menuExit.setMnemonic(KeyEvent.VK_X);
		_menuExit.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
            	SWDesignerFrame.this.windowClosed();
			}
		});

		//
		//_menuAdd
		//
		_menuAdd.setName("&Add");
		_menuAdd.setText("Add");
		_menuAdd.setMnemonic(KeyEvent.VK_A);
		_menuAdd.setEnabled(_onOffAddDel);
		_menuAdd.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_A, ActionEvent.CTRL_MASK));
		_menuAdd.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				onProjectAdd();
			}
		});

		//
		//_cmenuDelete
		//
		_menuDelete.setName("_Delete");
		_menuDelete.setText("Delete");
		_menuDelete.setMnemonic(KeyEvent.VK_D);
		_menuDelete.setEnabled(_onOffAddDel);
		_menuDelete.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_D, ActionEvent.CTRL_MASK));
		_menuDelete.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				onProjectDelete();
			}
		});


		//
		//_menuDiagram
		//
		_menuDiagram.setMnemonic(KeyEvent.VK_D);
		_menuDiagram.add(_menuAdd);
		_menuDiagram.add(_menuDelete);

		//
		//_menuBar
		//
        _menuBar.add(_menuProject);
        _menuBar.add(_menuDiagram);

		//
        //Popup menu
        //


        //
        //_cmenuDelete
        //
        _cmenuDelete.setName("&cmenuDelete");
        _cmenuDelete.setText("Delete");
        _cmenuDelete.setMnemonic(KeyEvent.VK_D);
        _cmenuDelete.addActionListener(new ActionListener(){
        	public void actionPerformed(ActionEvent e){
				onProjectDelete();
			}
        });

        //
		//_cmenuRename
		//
		_cmenuRename.setName("&cmenuRename");
		_cmenuRename.setMnemonic(KeyEvent.VK_R);
		_cmenuRename.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
			}
		});

        //
        //popup
        //
        _popupMenu.setName("_cmenuDia");
        _popupMenu.add(_cmenuDelete);


        //
        //_tree
        //
        _tree.setEditable(true);
        _tree.setShowsRootHandles(true);
        _tree.getSelectionModel().setSelectionMode
            (TreeSelectionModel.SINGLE_TREE_SELECTION);
        _tree.addKeyListener(new KeyAdapter(){
        	public void	keyReleased(KeyEvent e) {
        		if(e.getKeyCode() == KeyEvent.VK_ENTER)
        		{
        			onSelectionTree();
        		}
        	}
        });
        _tree.addMouseListener(new MouseAdapter(){
        	public void mouseClicked(MouseEvent e){
        		if(e.getClickCount() == 2){
        			treeDoubleClicked();
        		}

        		if(e.getButton() == MouseEvent.BUTTON3){
        			popupMenu_Show(e);
        		}
    		}
    	});
	    _tree.addTreeSelectionListener(new TreeSelectionListener(){
	    	public void valueChanged(TreeSelectionEvent e) {
	    		onSelectionTree();
	    	}
	    });

        //
        //_desktop
        //
      	_desktop.setName("_desktop");
      	_desktop.setBackground(new Color(242, 242, 242));
        //Make dragging a little faster but perhaps uglier.
        _desktop.setDragMode(JDesktopPane.OUTLINE_DRAG_MODE);

        //
        //_split
        //
        _split.setName("_split");
        _split.setLocation(152, 0);
        _split.setDividerLocation(150);
        _split.setSize(3,390);
        _split.setLeftComponent(_tree);
        _split.setRightComponent(_deskScroll);

        add(_split);

        setTitle("MindFusion.Diagramming sample: SWDesigner");
        setJMenuBar(_menuBar);
        setSize(new Dimension(800, 700));

        // Add window listener.
        this.addWindowListener
        (
            new WindowAdapter() {
                public void windowClosing(WindowEvent e) {
                    SWDesignerFrame.this.windowClosed();
                }
            }
        );
    }


    /**
     * Shutdown procedure when run as an application.
     */
    protected void windowClosed() {

    	// TODO: Check if it is safe to close the application

        // Exit application.
        System.exit(0);
    }
private boolean hasSelDiagNode = false;

    public boolean CloseProject()
    	throws XmlException
    {
    	if (_project != null)
    	{
    		// Save diagrams

 	 		for(int i = 0; i < _desktop.getAllFrames().length; i++)
 			{
    			DiagramForm child = (DiagramForm)_desktop.getAllFrames()[i];
    			child.Save();
    		}

    		boolean close = false;

    		if(_project.getIsModified())
    		{
    			int result = JOptionPane.showConfirmDialog(this,
    					"The current project has been modified. Save?", "Closing project",
    					JOptionPane.YES_NO_CANCEL_OPTION);

    			switch (result)
    			{
    				case JOptionPane.YES_OPTION:
    					_project.Save();
    					close = true;
    					break;
    				case JOptionPane.NO_OPTION:
    					close = true;
    					break;
    				case JOptionPane.CANCEL_OPTION:
    					close = false;
    					break;
    			}
    		}

    		if(!close)
				return close;

			//Close forms
			for(int i = 0; i < _desktop.getAllFrames().length; i++)
			{
				DiagramForm child = (DiagramForm)_desktop.getAllFrames()[i];
				child.dispose();
			}

			//Remove tree items
			_top.removeAllChildren();
			_tree.removeAll();

			_tree.repaint();
			((DefaultTreeModel)_tree.getModel()).reload(_top);

			_desktop.removeAll();
			_desktop.repaint();

			_project = null;
			UpdateMenus();

    	}

    	return true;
    }

NodeDiagramRef _nodeRef = null;

	public boolean onSelectionTree()
	{

       	DefaultMutableTreeNode node = (DefaultMutableTreeNode)_tree.getLastSelectedPathComponent();
       	if(node == null)
		{
			hasSelDiagNode = false;
			return false;
		}

		if(node.toString().compareTo("Project") == 0)
		{
			hasSelDiagNode = false;
			return false;
		}

		_nodeRef = (NodeDiagramRef)node;
		try{
			_nodeRef.getDiagramForm().setSelected(true);
			hasSelDiagNode = true;
		}
		catch(java.beans.PropertyVetoException exp){
			System.out.println(exp.getMessage());
		}

		return true;
    }

	private void onMenuEntered()
	{
		if(hasSelDiagNode)
			_printPreview.setEnabled(true);
		else
			_printPreview.setEnabled(false);
	}

    private void onFileNew()
    {
    	AddProjectDialog dlg = new AddProjectDialog(this);
	   	dlg.setVisible(true);

	   	if(dlg.getAccepted() == true)
	   	{

			if(!_projectDir.exists())
				_projectDir.mkdir();


			try{
				CloseProject();
			}catch (XmlException exp)
			{
				JOptionPane.showMessageDialog(this, exp.getMessage());
			}

	   		_project = new Project();
			_project.Create(getProjectFolder() +
					Tools.FixFileName(dlg.getProjectTitle()) + File.separator,
					dlg.getProjectTitle());

	   		UpdateMenus();
	   	}
    }

    private void _menuProjectSelected(Diagram d)
    {
    	Diagram diagram = d;

    	if(diagram == null)
    		return;

    	// See if diagram is already open
    	for(int i = 0; i < _desktop.getAllFrames().length; i++)
    	{
    		DiagramForm child = (DiagramForm)_desktop.getAllFrames()[i];
    		if(child.getDiagram() == diagram)
    		{
    			try{
    				child.setSelected(true);
    			}
    			catch(java.beans.PropertyVetoException exp){
    				return;
    			}

    		}

    		DiagramForm form = new DiagramForm();
    		try{
    			form.setDiagram(diagram);
    		}
    		catch(java.io.FileNotFoundException exp)
    		{
    			JOptionPane.showMessageDialog(this, exp.getMessage());
    		}
    		form.setTitle("Class diargam - [" + diagram.getName() + "]");
    		form.show(true);


    	}
    }

    private void onFileOpen()
   	{
   		int x = 30;
   		int y = 30;
    	if(_fileChooser.showOpenDialog(this) == JFileChooser.APPROVE_OPTION)
    	{
    		try
    		{
    			CloseProject();
    		}
    		catch (XmlException e){}

    		_project = new Project();

    		String  m = _fileChooser.getSelectedFile().getAbsolutePath();

    			try
				{
					_project.Load(m);
				} catch (XmlReaderException e)
				{
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			
			_top.removeAllChildren();
			_tree.removeAll();

			// Initialize diagrams
			for(int i = 0; i < _project.getDiagrams().length; i++)
			{
				Diagram d = _project.getDiagrams()[i];

				NodeDiagramRef node = new NodeDiagramRef(d.getID(), d, new DiagramForm());
				node.getDiagramForm().setBounds(x,y,400,400);
				_desktop.add(node.getDiagramForm());
				_top.add(node);

				Diagram diagram = d;

				try{
					node.getDiagramForm().setDiagram(diagram);
				}
				catch(FileNotFoundException exp)
				{
					System.out.println(exp.getMessage());
				}
				x += 30;
				y += 30;
			}
			_tree.repaint();
			((DefaultTreeModel)_tree.getModel()).reload(_top);

		}
    	UpdateMenus();
    }

    private void onFileClose()
    	throws XmlException
    {
    	CloseProject();
    }

    private void onFileSave()
    {

    	if(_project  != null)
    	{

    		// Save all open diagrams
    		for(int i = 0; i < _desktop.getAllFrames().length; i++)
    		{
    			DiagramForm dgf = (DiagramForm)_desktop.getAllFrames()[i];
    			Diagram df = dgf.getDiagram();

    			dgf.Save();
    		}

    		try{
    			_project.Save();
    		}
    		catch(XmlException exp){
    			JOptionPane.showMessageDialog(this, exp.getMessage());
    		}
    	}
    }

	public void onFilePrintPreview()
	{
		NodeDiagramRef node = (NodeDiagramRef)_tree.getLastSelectedPathComponent();
		node.getDiagramForm().getDiag().printPreview();
	}

    private void onProjectAdd()
    {
    	if(_project == null)
    		return;

    	AddDiagramDialog dlg = new AddDiagramDialog(this);

    	dlg.setVisible(true);

    	NodeDiagramRef nodeDiag;

    	if(dlg.getAccepted() == true)
    	{

    		// Check for unique name
    		String unique = dlg.getTextDiagram();
    		int index = 0;
    		boolean found = false;

    		do
    		{
    			found = false;
    			for(Diagram d : _project.getDiagrams())
    			{
    				if(d.getID().compareTo(unique) == 0)
    				{
    					found = true;
						break;
    				}

    			}

    			if(!found)
    				break;


    			unique = dlg.getTextDiagram() + index;
    			index++;


    		}while(found);

    		Diagram diagram = new Diagram(dlg.getTextDiagram(), unique);
    		DiagramForm dgForm = new DiagramForm();

    		try
    		{
    			dgForm.setDiagram(diagram);
    		}
    		catch (FileNotFoundException e)
    		{
    		}

    		// Add to tree view
    		nodeDiag = new NodeDiagramRef(dlg.getTextDiagram(),
    						diagram, dgForm);

    		_top.add(nodeDiag);
    		((DefaultTreeModel)_tree.getModel()).reload(_top);


    		_project.AddDiagram(nodeDiag.getDiagram());
  			_desktop.add(nodeDiag.getDiagramForm());
  			try{
  				nodeDiag.getDiagramForm().setSelected(true);

  			}
  			catch(java.beans.PropertyVetoException exp)
  			{
  				exp.getMessage();
  			}
  			_menuProjectSelected(nodeDiag.getDiagram());
    	}
    }

    private void onProjectDelete()
    {
    	if(!onSelectionTree())
    		return;


    	if(JOptionPane.showConfirmDialog(this, "Confirm delete?", "Delete diagram",
    			JOptionPane.YES_NO_OPTION, JOptionPane.QUESTION_MESSAGE) != JOptionPane.YES_OPTION)
    		return;

    	for(int i = 0; i < _desktop.getAllFrames().length; i++)
    	{
    		DiagramForm dgf = (DiagramForm)_desktop.getAllFrames()[i];
    		if(dgf.getDiagram() == _nodeRef.getDiagram())
    		{
    			try
    			{
    				dgf.setClosed(true);
    			}
    			catch(java.beans.PropertyVetoException exp){
    				exp.getMessage();
    			}
    		}
    	}

    	DefaultMutableTreeNode parentNode = null;

  		_top.remove(_nodeRef);
    	((DefaultTreeModel)_tree.getModel()).reload(_top);

    	_project.RemoveDiagram(_nodeRef.getDiagram());

  		try
  		{
  			_nodeRef.getDiagramForm().setClosed(true);
    	}
    	catch(java.beans.PropertyVetoException exp)
    	{
    		exp.getMessage();
    	}

    	if(_top.getChildCount() == 0)
    	{
    		_menuSave.setEnabled(false);
    		_menuClose.setEnabled(false);
    		_menuAdd.setEnabled(false);
    		_menuDelete.setEnabled(false);
    	}

		UpdateMenus();
    }

    private void treeDoubleClicked()
   	{
   		DefaultMutableTreeNode node = (DefaultMutableTreeNode)_tree.getLastSelectedPathComponent();

		if(node == null)
			return;

		if(node.toString().compareTo("Project") == 0)
			return;

   		NodeDiagramRef nodeDiag = (NodeDiagramRef)node;

   		if(nodeDiag.getDiagramForm().isShowing())
   			return;

		for(int i = 0; i < _desktop.getAllFrames().length; i++)
		{
			try{
				nodeDiag.getDiagramForm().setSelected(true);
			}
			catch(java.beans.PropertyVetoException exp){
				System.out.println(exp.getMessage());
			}
		}

        DiagramForm form = new DiagramForm();
        try{
        	form.setDiagram(nodeDiag.getDiagram());
        }catch(FileNotFoundException e)
        {
        }
        form.setTitle(nodeDiag.getDiagram().getName());

       	_desktop.add(form);
        form.show();
        try
		{
			form.setSelected(true);
		}
        catch(java.beans.PropertyVetoException exp)
        {
        	System.out.println(exp.getMessage());
        }
	}


    public static String getProjectFolder()
    {
		 return _projectDir + File.separator;
    }

    public void UpdateMenus()
    {
    	_menuClose.setEnabled(_project != null);
		_menuDelete.setEnabled(_project != null);
		_menuAdd.setEnabled(_project != null);
		_menuSave.setEnabled(_project != null);
    }

    public Diagram getSelectedDiagram()
	{

		if(_top.getChildAt(row) == null)
			return null;

		NodeDiagramRef ndr = (NodeDiagramRef)_top.getChildAt(row);
		Diagram diag = (Diagram)ndr.getDiagram();

		return diag;
	}

    int row = 0;

    public void popupMenu_Show(MouseEvent e)
    {
    	int clickX = e.getX();
    	int clickY = e.getY();

    	int rowEndY = 0;
    	for(int row = 0; row <= _top.getChildCount(); row++)
    	{
    		rowEndY += 20;
    		if(rowEndY > clickY && row > 0)
			{
				_tree.setSelectionRow(row);
				_popupMenu.show(e.getComponent(), clickX, clickY);
				break;
			}
    	}
    }

    public void onRenameMenu_Click()
    {

	}
}

class Tools
{
	public static String FixFileName(String name)
	{
		String result = name;
		int index = -1;

		while((index = result.indexOf(File.pathSeparatorChar)) != -1)
			result.indexOf(index, 1);

		return result;
	}
}